public class Address
{
    private String town;
    private String street;
    private int    number;
    
    public Address(String town, String street, int number) {
        if (town == null) throw new NullPointerException("town");
        if (street == null) throw new NullPointerException("street");
        this.town = town;
        this.street = street;
        this.number = number;
    }
    
    public String toString() {
        return street + " " + number + ", " + town;
    }
    
    public boolean equals(Object obj) {
        if (!(obj instanceof Address)) {
            return false;
        }
        Address a = (Address) obj;
        return this.town.equals(a.town) &&
                this.street.equals(a.street) && 
                this.number == a.number;
    }
    
    public int hashCode() {
        int hash = 4;
        hash = hash * 31 + town.hashCode();
        hash = hash * 31 + street.hashCode();
        hash = hash * 31 + number;
        return hash;
    }
}






